/***************************************************************************
 *   Copyright (C) 2010 by Volker Lanz <vl@fidra.de>                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA            *
 ***************************************************************************/

#include "veneer/system.h"

#include <kstandarddirs.h>
#include <kglobal.h>

#include <QString>
#include <QStringList>
#include <QDebug>
#include <QFile>
#include <QDir>
#include <QCoreApplication>

namespace Veneer
{

	QStringList findDataDirPaths()
	{
		QStringList rval;
		rval = KGlobal::dirs()->resourceDirs("data");

		for (int i = 0; i < rval.size(); i++)
			rval[i].append(QDir::separator() + QCoreApplication::applicationName().toLower() + QDir::separator());

		return rval;
	}

	QString findFilePath(const QString& fileName)
	{
		const QString dir = KStandardDirs::locateLocal("data", QString(), true);
		return dir + QDir::separator() + QCoreApplication::applicationName().toLower() + QDir::separator() + fileName;
	}

	QString findExistingFilePath(const QString& fileName)
	{
		QStringList dirs = findDataDirPaths();

		foreach (const QString& s, dirs)
		{
			const QString f = s + QDir::separator() + fileName;
			if (QFile::exists(f))
				return f;
		}

		return QString();
	}

}
